/*
 * Copyright (c) 1985 Thomas L. Quarles
 */
#ifndef LINT
static char rcsid[] =
    "INPlist.c $Revision: 7.1 $ on $Date: 86/03/31 11:50:52 $";
#endif LINT

    /* INPlist(file,deck,type)
     *  provide an input listing on the specified file of the given
     *  card deck.  The listing should be of either PHYSICAL or LOGICAL
     *  lines as specified by the type parameter.
     */


#include <stdio.h>
#include "INPdefs.h"


void
INPlist(file,deck,type)
    FILE *file;
    card *deck;
    int type;
{

    card *here;
    card *there;

    if(type == LOGICAL) {
        for(here = deck;here != NULL;here = here->nextcard) {
            fprintf(file,"%6d : %s\n",here->linenum, here->line);
            if(here->error != (char *)NULL) {
                fprintf(file,"%s",here->error);
            }
        }
    } else if (type == PHYSICAL) {
        for(here = deck;here != NULL;here = here->nextcard) {
            if(here->actualLine == (card *)NULL) {
                fprintf(file,"%6d : %s\n",here->linenum,here->line);
                if(here->error != (char *)NULL) {
                    fprintf(file,"%s",here->error);
                }
            } else {
                for(there = here->actualLine;there != NULL;
                        there=there->nextcard) {
                    fprintf(file,"%6d : %s\n",there->linenum, there->line);
                    if(there->error != (char *)NULL) {
                        fprintf(file,"%s",there->error);
                    }
                }
            }
        }
    }
}
                    
                
