/* data structure for ssg approach to switch permutation problem */
/* author: Hormoz Yaghutiel, Advisor: Alberto Sangiovanni-Vincentelli */
/* last change: 7/17/87 */

#include "ADglobals.h"

struct _permobj {
    struct _module *module; /* the module this object belongs to */

	int numterms; /* Number of ungrounded terminals of the module */
	/* array of shifted objpin limits for untransormed (NO)
		and transformed (YES) object */
	/* For transformed, each array element is lowxlim or hixlim
			subtracted by the coordinate of the pin after transformation */
	/* Assume maximum of 10 ungrounded pins per block */
	/* The cost function is wrt the left edge of the module */
	int limitlist[3][20];
	int fvalue[3][20]; /* function cost at above breakpoints */
	int cost; /* cost of the node to be at current position */
	int tmpcost; /* tentative cost of the object if it is moved */
};

/* a node of state space graph */
/* each object to be permuted is assumed to be shifted by an amount equal
to xsep from its immediate left hand side neighbor */

struct _ssgnode {
    struct _permobj *lastobj; /* last object in permutation corresponding
                                to this node */

    int level; /* for n permutable objects this is between 0 and n+1 */
    struct _ssgnode *parent; /* the active parent in the graph */

    struct _ssgnode *next; /* next cost-sorted element in open lists */

    struct _ssgnode *leftson; /* for binary search tree */
    struct _ssgnode *rightson; /* the key is the bit representation */

    set_t *setrep; /* set representation of this node */ 
    int whichset; /* OPEN or CLOSED */

    int xtrans;
    int xsep;
    int transform;

    double cost; /* cost of the the tentative shortest path to this node */
    double hfunc; /* value of hueristic function for this node */
    double est_cost; /* estimated cost of the shortest path through this node */
};
